import router from './router'
import { isRelogin } from '@/config/axios/service'
import { getAccessToken, removeToken } from '@/utils/auth'
import { useTitle } from '@/hooks/web/useTitle'
import { useNProgress } from '@/hooks/web/useNProgress'
import { usePageLoading } from '@/hooks/web/usePageLoading'
import { useDictStoreWithOut } from '@/store/modules/dict'
import { useUserStoreWithOut } from '@/store/modules/user'
import { usePermissionStoreWithOut } from '@/store/modules/permission'
import { getTenantId, getAppId } from '@/utils/auth'
import cache from '@/plugins/cache'

const { start, done } = useNProgress()

const { loadStart, loadDone } = usePageLoading()
// 路由不重定向白名单
const whiteList = ['/login', '/social-login', '/auth-redirect', '/bind', '/register', '/swagger']

// 路由加载前
router.beforeEach(async (to, from, next) => {
  start()
  loadStart()
  if (getAppId() && to.query?.appId && getAppId() != to.query?.appId) {
    removeToken()
    cache?.local?.delete('appInfo')
    cache?.local?.delete('roleRouters')
    cache?.local?.delete('user')
    cache?.local?.delete('App_ID')
    next(`/login?tenantId=${to.query?.tenantId}&appId=${to.query?.appId}`)
  } else {
    if (getAccessToken()) {
      if (to.path === '/login') {
        next({ path: '/' })
      } else {
        // 获取所有字典
        const dictStore = useDictStoreWithOut()
        const userStore = useUserStoreWithOut()
        const permissionStore = usePermissionStoreWithOut()
        if (!dictStore.getIsSetDict) {
          await dictStore.setDictMap()
        }
        if (!userStore.getIsSetUser) {
          isRelogin.show = true
          await userStore.setUserInfoAction()
          isRelogin.show = false
          // 后端过滤菜单
          await permissionStore.generateRoutes()
          permissionStore.getAddRouters.forEach((route) => {
            router.addRoute(route) // 动态添加可访问路由表
          })
          const redirectPath = from.query.redirect || to.path
          const redirect = decodeURIComponent(redirectPath)
          const nextData = to.path === redirect ? { ...to, replace: true } : { path: redirect }
          next(nextData)
        } else {
          next()
        }
      }
    } else {
      if (whiteList.indexOf(to.path) !== -1) {
        next()
      } else {
        const tenantId = getTenantId()
        const appId = getAppId()
        if (tenantId && appId) {
          next(`/oa/login?tenantId=${tenantId}&appId=${appId}&redirect=${to.fullPath}`) // 否则全部重定向到登录页
        } else {
          next(`/oa/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
        }
      }
    }
  }
})

router.afterEach((to) => {
  useTitle(to?.meta?.title)
  done() // 结束Progress
  loadDone()
})
